package com.mumayi.http.factory;

import com.mumayi.http.dao.HttpApi;
import com.mumayi.http.impl.HttpClientGetImpl;
import com.mumayi.http.impl.HttpClientPostImpl;
import com.mumayi.http.impl.HttpConnectGetImpl;
import com.mumayi.http.impl.HttpConnectPostImpl;

public class HttpApiFactory
{
	public static HttpApi getHttpApi(int type)
	{
		HttpApi httpApi = null;
		switch (type)
		{
			case HttpApi.HTTP_CONNECT_GET:
				httpApi = HttpConnectGetImpl.getInstance();
				break;
			case HttpApi.HTTP_CONNECT_POST:
				httpApi = HttpConnectPostImpl.getInstance();
				break;
			case HttpApi.HTTP_CLIENT_GET:
				httpApi = HttpClientGetImpl.getInstance();
				break;
			case HttpApi.HTTP_CLIENT_POST:
				httpApi = HttpClientPostImpl.getInstance();
				break;
			default:
				httpApi = HttpClientGetImpl.getInstance();
				break;
		}
		return httpApi;
	}
}
