package com.mumayi.http.impl;

import java.net.HttpURLConnection;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.StatusLine;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.entity.BufferedHttpEntity;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import com.mumayi.http.dao.HttpApi;
import com.mumayi.http.util.MyLog;
import com.mumayi.http.util.NetWorkUtil;

public class HttpClientPostImpl implements HttpApi
{
	private static HttpClientPostImpl mHttpClientPostImpl = null;
	private MyHttpRequestRetryHandler requestRetryHandler = null;
	private HttpClientPostImpl()
	{
		requestRetryHandler = new MyHttpRequestRetryHandler();
	}
	public static HttpClientPostImpl getInstance()
	{
		if(mHttpClientPostImpl == null)
		{
			mHttpClientPostImpl = new HttpClientPostImpl();
		}
		return mHttpClientPostImpl;
	}
	@Override
	public String getUrlContentString(String url) throws Exception
	{
		// TODO Auto-generated method stub
		return new String(getUrlContentByte(url));
	}

	@Override
	public String getUrlContentString(String url, String[] key, Object[] value) throws Exception
	{
		// TODO Auto-generated method stub
		return new String(getUrlContentByte(url,key,value));
	}

	@Override
	public byte[] getUrlContentByte(String url) throws Exception
	{
		// TODO Auto-generated method stub
		return getUrlContentByte(url,null,null);
	}

	@Override
	public byte[] getUrlContentByte(String url, String[] key, Object[] value) throws Exception
	{
		HttpClient httpClient = NetWorkUtil.getHttpClient(requestRetryHandler);
		HttpPost httpPost = new HttpPost(url);
		if (key != null && value != null)
		{
			List<NameValuePair> params = new ArrayList<NameValuePair>();
			for(int i = 0 ;i<key.length;i++)
			{
				params.add(new BasicNameValuePair(key[i], String.valueOf(value[i])));
			}
			httpPost.setEntity(new UrlEncodedFormEntity(params, HTTP.UTF_8));
		}
		HttpResponse response = httpClient.execute(httpPost);
		if(response!=null)
		{
			StatusLine statusLine = response.getStatusLine();
			int code = statusLine.getStatusCode();
			String mess = "请求 "+url+"  返回状态吗： "+code;
			L(mess);
			if(code == HttpURLConnection.HTTP_OK)
			{
				HttpEntity  entity = response.getEntity();  
				if(entity!=null)
				{
					entity = new BufferedHttpEntity(entity);  
					return EntityUtils.toByteArray(entity);
				}
			}
			else
			{
				throw new Exception(mess);
			}
		}
		
		return null;
	}
	private void L(String mess)
	{
		MyLog.i(getClass().toString(), mess);
	}
	private void L(Throwable e)
	{
		MyLog.e(getClass().toString(), e);
	}
}
