package com.mumayi.http.impl;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;

import com.mumayi.http.dao.HttpApi;
import com.mumayi.http.util.Constants;
import com.mumayi.http.util.MyLog;
import com.mumayi.http.util.NetWorkUtil;

public class HttpConnectGetImpl implements HttpApi
{

	private static HttpConnectGetImpl mHttpConnectGetImpl = null;
	private int reconnectNumber = Constants.HTTP_CLIENT_REST_CONNECT_SUM;
	private HttpConnectGetImpl(){};
	
	public static HttpConnectGetImpl getInstance()
	{
		if(mHttpConnectGetImpl == null)
		{
			mHttpConnectGetImpl = new HttpConnectGetImpl();
		}
		return mHttpConnectGetImpl;
	}
	
	
	@Override
	public String getUrlContentString(String url) throws Exception
	{
		byte[] data = getUrlContentByte(url);
		if(data!=null && data.length > 0)
		{
			return new String(data);
		}
		else
		{
			return null;
		}
	}

	@Override
	public String getUrlContentString(String url, String[] key, Object[] value) throws Exception
	{
		byte[] data = getUrlContentByte(url,key,value);
		if(data!=null && data.length > 0)
		{
			return new String(data);
		}
		else
		{
			return null;
		}
	}

	@Override
	public byte[] getUrlContentByte(String url ) throws Exception
	{
		reconnectNumber = Constants.HTTP_CLIENT_REST_CONNECT_SUM;
		for(int i =0 ;i<  Constants.HTTP_CLIENT_REST_CONNECT_SUM;i++)
		{
			HttpURLConnection conn = NetWorkUtil.getNetWorkConnectGET(url);
			int code = conn.getResponseCode();
			int len = conn.getContentLength();
			L("请求："+url+"  返回状态码："+code +"  数据长度: "+len);
			if(code==HttpURLConnection.HTTP_OK ||code==HttpURLConnection.HTTP_PARTIAL)
			{
				InputStream is = conn.getInputStream();
				return readInputStream(is,conn.getContentLength());
			}
		}
		return null;
	}

	@Override
	public byte[] getUrlContentByte(String url, String[] key, Object[] value) throws Exception
	{
		if (key != null && value != null)
		{
			StringBuffer sb = new StringBuffer();
			if(url.contains("?"))
			{
				sb.append("&");
			}
			else
			{
				sb.append("?");
			}
			
			for (int i = 0; i < key.length; i++)
			{
				if (i == 0)
				{
					sb.append(key[i] + "=" + value[i]);
				}
				else
				{
					sb.append("&" + key[i] + "=" + value[i]);
				}
			}
			url = url + sb.toString();
		}
		return getUrlContentByte(url);
	}
	
	
//	/**
//	 * 读取流中的数据
//	 *
//	 * @param stream
//	 * @param len
//	 * @return
//	 * @throws Exception
//	 * @author 小包
//	 * @time 2013-6-14 下午4:21:39
//	 */
//	private byte[] readInputStream(InputStream stream, int len) throws Exception
//	{	
//		BufferedInputStream bis = new BufferedInputStream(stream, len);
//		byte[] buffer = new byte[len];
//		bis.read(buffer);
//		stream.close();
//		bis.close();
//		return buffer;
//	}
	
	/**
	 * 读取流中的数据
	 *
	 * @param stream
	 * @param size
	 * @return
	 * @throws Exception
	 * @author 小包
	 * @time 2013-6-14 下午4:21:39
	 */
	private byte[] readInputStream(InputStream stream, int size) throws Exception
	{	
		BufferedInputStream bis  =null;
		if(size>0)
		{
			bis = new BufferedInputStream(stream, size);
		}
		else
		{
			bis = new BufferedInputStream(stream);
		}
		ByteArrayOutputStream outStream = new ByteArrayOutputStream();
         byte[] buffer = new byte[1024];
         int len = 0;
         while ((len = bis.read(buffer)) != -1) {
             outStream.write(buffer, 0, len); // 用一个输出流来接收网络的数据流
         }
        outStream.flush();
        outStream.close();
		stream.close();
		bis.close();
		return outStream.toByteArray();
	}
	
	private void L(String mess)
	{
		MyLog.i(getClass().toString(), mess);
	}
	private void L(Throwable e)
	{
		MyLog.e(getClass().toString(), e);
	}
	
}
