package com.mumayi.http.impl;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URLEncoder;

import org.apache.http.protocol.HTTP;

import com.mumayi.http.dao.HttpApi;
import com.mumayi.http.util.Constants;
import com.mumayi.http.util.MyLog;
import com.mumayi.http.util.NetWorkUtil;

public class HttpConnectPostImpl implements HttpApi
{
	private static HttpConnectPostImpl mHttpConnectPostImpl = null;
	private HttpConnectPostImpl(){};
	
	public static HttpConnectPostImpl getInstance()
	{
		if(mHttpConnectPostImpl == null)
		{
			mHttpConnectPostImpl = new HttpConnectPostImpl();
		}
		return mHttpConnectPostImpl;
	}
	
	@Override
	public String getUrlContentString(String url) throws Exception
	{
		// TODO Auto-generated method stub
		return new String(getUrlContentByte(url));
	}

	@Override
	public String getUrlContentString(String url, String[] key, Object[] value) throws Exception
	{
		// TODO Auto-generated method stub
		return new String(getUrlContentByte(url,key,value));
	}

	@Override
	public byte[] getUrlContentByte(String url) throws Exception
	{
		// TODO Auto-generated method stub
		return getUtlContentByte(url,"");
	}

	@Override
	public byte[] getUrlContentByte(String url, String[] key, Object[] value) throws Exception
	{
		StringBuilder sb = new StringBuilder();
		if (key != null && value != null)
		{
			// 要传的参数
			for (int i = 0; i < key.length; i++)
			{
				String content = URLEncoder.encode(key[i], HTTP.UTF_8) + "=" + URLEncoder.encode(String.valueOf(value[i]), HTTP.UTF_8);
				if(i==0)
				{
					sb.append(content);
				}
				else
				{
					sb.append("&"+content);
				}
			}
		}
		return getUtlContentByte(url, sb.toString());
	}

	private byte[] getUtlContentByte(String url, String content) throws Exception
	{
		int code = 0;
		int len = 0;
		for(int i = 0;i<Constants.HTTP_CLIENT_REST_CONNECT_SUM;i++)
		{
			HttpURLConnection conn = NetWorkUtil.getNetWorkConnectPOST(url);
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			out.writeBytes(content);
			out.flush();
			out.close();
			code = conn.getResponseCode();
			len = conn.getContentLength();
			L("请求：" + url + "  返回状态码：" + code + "  数据长度: " + len +"  content "+ content);
			if (code == HttpURLConnection.HTTP_OK || code == HttpURLConnection.HTTP_PARTIAL)
			{
				return readInputStream(conn.getInputStream());
			}
		}
		throw new Exception("请求：" + url + "  返回状态码：" + code + "  数据长度: " + len);
	}

	/**
	 * 读取流中的数据
	 *
	 * @param stream
	 * @return
	 * @throws Exception
	 * @author 小包
	 * @time 2013-6-14 下午4:21:39
	 */
	private byte[] readInputStream(InputStream stream) throws Exception
	{	
		BufferedInputStream bis = new BufferedInputStream(stream);
		ByteArrayOutputStream outStream = new ByteArrayOutputStream();
         byte[] buffer = new byte[1024];
         int len = 0;
         while ((len = bis.read(buffer)) != -1) {
             outStream.write(buffer, 0, len); // 用一个输出流来接收网络的数据流
         }
        outStream.flush();
        outStream.close();
		stream.close();
		bis.close();
		return outStream.toByteArray();
	}
	
	private void L(String mess)
	{
		MyLog.i(getClass().toString(), mess);
	}

	private void L(Throwable e)
	{
		MyLog.e(getClass().toString(), e);
	}

}
